#include "idc.idc"

static OpenLog()
{
   auto flog;
   // open output file
   flog = fopen("VMout.LOG", "wt"); 
   if(flog == 0) {
      Message("Can't open LOG file\n");
      return -1;
   }
   if(fseek(flog, 0, 2)!=0) {    // from end file
      Message("Bad seek pointer\n");
      fclose(flog);                // close file
      return -1;
   }
   return flog;
}

static OutLog(flog, msg)
{
   if(flog != -1)
      fprintf(flog, "%s", msg);
}

static CloseLog(flog)
{
   if(flog != -1)
      fclose(flog);
}

static UncryptOpcode(ea, key)
{
   auto db;
   db = Byte(ea);
   db = db + key;
   db = ~db;
   db = db - 1;
   db = rotate_left(db, 1, 8, 0);
   db = (db + 1) & 0xFF;
   return db;
}

static main()
{
   auto ea, key, oc, b, w, d, a;
   auto flog, msg;

   flog = OpenLog();
   ea = ScreenEA();
   key = ea;
   for(;;) {
      oc = UncryptOpcode(ea, key&0xFF);
      a = key + oc;
      key = (key&0xFFFFFF00) | ((a)&0xFF);
      Message("Key -> %08X\n", key);
      ea = ea + 1;
      if(oc == 0 || oc == 103 || oc == 112 || oc == 228) {
         msg = form("%08X | %02X          go to[ebp+0] (new VM)\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
         break;
      } else
      if(oc ==  1 || oc ==  5 || oc ==  9 || oc == 13 || oc == 17 || oc == 21 || 
         oc == 25 || oc == 29 || oc == 33 || oc == 37 || oc == 41 || oc == 45 || 
         oc == 49 || oc == 53 || oc == 57 || oc == 61) {
         msg = form("%08X | %02X          ebp-4; dword[memory[edi+%02d]] -> dword[ebp+0]\n", ea-1, oc, (((~(-(oc-1)))+1)&0x3C));
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 2 || oc == 118 || oc == 169 || oc == 246) {
         msg = form("%08X | %02X          dword[ebp+4] -> dword(ss:[[ebp+0]]); ebp+8\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc ==  3 || oc ==  7 || oc == 11 || oc == 15 || oc == 19 || oc == 23 || 
         oc == 27 || oc == 31 || oc == 35 || oc == 39 || oc == 43 || oc == 47 || 
         oc == 51 || oc == 55 || oc == 59 || oc == 63) {
         msg = form("%08X | %02X          dword[ebp+0] -> dword[memory[edi+%02d]]; ebp+4\n", ea-1, oc, (((~(-(oc-1)))+1)&0x3C));
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 4 || oc == 83 || oc == 195) {
         msg = form("%08X | %02X          word[ebp+2] * dword[ebp+0] -> dword[ebp+6][ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 6 || oc == 58 || oc == 123 || oc == 186 || oc == 226) {
         msg = form("%08X | %02X          dword64[ebp+0][ebp+4] SHLD byte[ebp+8] -(ebp+2)-> dword[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 8 || oc == 44 || oc == 96 || oc == 171 || oc == 189 || oc == 235) {
         msg = form("%08X | %02X          dword[ebp+0] SHL byte[ebp+4] -> dword[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 10 || oc == 114 || oc == 156) {
         msg = form("%08X | %02X          byte(ss:[[ebp+0]]) -(ebp+2)-> word[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 12 || oc == 24 || oc == 32 || oc == 163 || oc == 251) {
         w = Word(ea);
         w = w ^ (key&0xFFFF);
         w = rotate_left(w, -12, 16, 0);
         w = w - 0x64FA;
         w = ~w;
         w = rotate_left(w, -7, 16, 0);
         w = -w;
         a = key ^ w;
         key = (key&0xFFFF0000) | ((a)&0xFFFF);
         ea = ea + 2;
         msg = form("%08X | %02X %04X     ebp-2; %04X -> word[ebp+0]\n", ea-3, oc, w, w);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 14 || oc == 213) {
         b = Byte(ea);
         b = b - key&0xFF;
         b = b - 1;
         b = rotate_left(b, 6, 8, 0);
         b = b - 1;
         b = rotate_left(b, -2, 8, 0);
         b = -b;
         b = rotate_left(b, 3, 8, 0);
         b = b & 0xFF;
         a = key - b;
         key = (key&0xFFFFFF00) | ((a)&0xFF);
         ea = ea + 1;
         msg = form("%08X | %02X %02X       word[ebp+0] -> byte[memory[edi+%d]]; ebp+2\n", ea-2, oc, b, b);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 16 || oc == 22 || oc == 89 || oc == 216) {
         msg = form("%08X | %02X          byte[[ebp+0]] -(ebp+2)-> word[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 18 || oc == 131 || oc == 151) {
         b = Byte(ea);
         b = b - key&0xFF;
         b = rotate_left(b, -1, 8, 0);
         b = b - 1;
         b = ~b;
         b = b ^ 0x8C;
         b = -b;
         b = b & 0xFF;
         a = key - b;
         key = (key&0xFFFFFF00) | ((a)&0xFF);
         ea = ea + 1;
         msg = form("%08X | %02X %02X       ebp-2; 00%02X -> word[ebp+0]\n", ea-2, oc, b, b);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 20 || oc == 72 || oc == 76 || oc == 122 || oc == 196 || oc == 212) {
         msg = form("%08X | %02X          dword(ss:[[ebp+0]]) -> dword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 26 || oc == 177 || oc == 227) {
         msg = form("%08X | %02X          dword[ebp+0] -> eflags\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 28 || oc == 60 || oc == 237) {
         msg = form("%08X | %02X          word(ss:[[ebp+0]]) -(ebp-2)-> word[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 30 || oc == 84 || oc == 153 || oc == 198) {
         d = Dword(ea);
         d = d ^ key;
         d = d - 1;
         d = d ^ 0x8919A0D9;
         d = d - 1;
         d = rotate_left(d, -7, 32, 0);
         key = key ^ d;
         ea = ea + 4;
         msg = form("%08X | %02X %08X ebp-4; %08X -> dword[ebp+0]\n", ea-5, oc, d, d);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 34 || oc == 193 || oc == 217 || oc == 245) {
         msg = form("%08X | %02X          byte[ebp+0] SHR byte[ebp+2] -(ebp-2)-> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 36 || oc == 243 || oc == 252) {
         msg = form("%08X | %02X          calc CRC -> from dword[ebp+0], size dword[ebp+4] -(ebp+4)-> dword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 38 || oc == 40 || oc == 77 || oc == 125 || oc == 219 || oc == 248) {
         msg = form("%08X | %02X          byte[ebp+0] SHL byte[ebp+2] -(ebp-2)-> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 42 || oc == 93 || oc == 94 || oc == 182 || oc == 183) {
         msg = form("%08X | %02X          word[ebp+0] SHL byte[ebp+2] -(ebp-2)-> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 46 || oc == 88 || oc == 90 || oc == 127 || oc == 135 || oc == 138) {
         b = Byte(ea);
         b = b - key&0xFF;
         b = rotate_left(b, -1, 8, 0);
         b = b - 1;
         b = ~b;
         b = b ^ 0x8C;
         b = -b;
         b = b & 0xFF;
         a = key - b;
         key = (key&0xFFFFFF00) | ((a)&0xFF);
         ea = ea + 1;
         msg = form("%08X | %02X %02X       ebp-4; 000000%02X -> dword[ebp+0]\n", ea-2, oc, b, b);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 48 || oc == 81 || oc == 113 || oc == 172 || oc == 173 || oc == 221) {
         msg = form("%08X | %02X          dword[ebp+0] -> ebp\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 50 || oc == 111 || oc == 210) {
         msg = form("%08X | %02X          dword[[ebp+0]] -> dword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 52 || oc == 56 || oc == 102 || oc == 116 || oc == 176 || oc == 222 || oc == 230) {
         msg = form("%08X | %02X          fdiv    dword ptr [ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 54 || oc == 70 || oc == 71 || oc == 194) {
         msg = form("%08X | %02X          word[ebp+4] -> dword([ebp+0]); ebp+6\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 62 || oc == 187 || oc == 234) {
         msg = form("%08X | %02X          dword[ebp+4] -> dword[[ebp+0]]; ebp+8\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 64 || oc == 134 || oc == 160 || oc == 188) {
         b = Byte(ea);
         b = b + key&0xFF;
         b = rotate_left(b, 6, 8, 0);
         b = b ^ 0x64;
         b = -b;
         b = b ^ 0x30;
         b = b & 0xFF;
         a = key + b;
         key = (key&0xFFFFFF00) | ((a)&0xFF);
         ea = ea + 1;
         msg = form("%08X | %02X %02X       word[ebp+0] -> word[edi+%d]; ebp+2\n", ea-2, oc, b, b&0xFF);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 65 || oc == 130 || oc == 164 || oc == 220) {
         msg = form("%08X | %02X          word[ebp+4] -> word(ss:[[ebp+0]]); ebp+6\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 66 || oc == 67 || oc == 109 || oc == 179 || oc == 191 || oc == 197) {
         msg = form("%08X | %02X          dword[ebp+0] SHR byte[ebp+4] -(ebp-2)-> dword[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 68 || oc == 87 || oc == 155 || oc == 240) {
         msg = form("%08X | %02X          word[[ebp+0]] -(ebp+2)-> word[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 69) {
         msg = form("%08X | %02X          byte[ebp+4] -> byte[[ebp+0]]; ebp+6\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 73 || oc == 101 || oc == 165 || oc == 208 || oc == 241) {
         msg = form("%08X | %02X          dword64[ebp+4][ebp+0]/dword[ebp+8] -> dword[ebp+8]; %dword[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 74 || oc == 95 || oc == 148 || oc == 157 || oc == 184 || oc == 255) {
         msg = form("%08X | %02X          dword[ebp+2][ebp+0]/word[ebp+4] -> word[ebp+6]; %word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 75 || oc == 133 || oc == 232) {
         msg = form("%08X | %02X          retf\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
         break;
      } else
      if(oc == 78 || oc == 129 || oc == 224 || oc == 249) {
         msg = form("%08X | %02X          word[ebp+0] -> bp\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 79 || oc == 167 || oc == 233 || oc == 242) {
         msg = form("%08X | %02X          ebp -(ebp-2)-> word[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 80 || oc == 115 || oc == 121 || oc == 145 || oc == 229) {
         w = Word(ea);
         w = w ^ (key&0xFFFF);
         w = rotate_left(w, -12, 16, 0);
         w = w - 0x64FA;
         w = ~w;
         w = rotate_left(w, -7, 16, 0);
         w = -w;
         a = key ^ w;
         key = (key&0xFFFF0000) | ((a)&0xFFFF);
         ea = ea + 2;
         msg = form("%08X | %02X %04X     ebp-4; %04X -> dword[ebp+0]\n", ea-3, oc, w, w);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 82 || oc == 91 || oc == 106 || oc == 136 || oc == 146 || oc == 162 || oc == 215 || oc == 244) {
         msg = form("%08X | %02X          dword[ebp+4] -> dword(es:[[ebp+0]]); ebp+8\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 85 || oc == 158 || oc == 199) {
         msg = form("%08X | %02X          dword[ebp+0] + dword[ebp+4] -> dword[ebp+4], FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 86 || oc == 159 || oc == 166 || oc == 174 || oc == 175) {
         b = Byte(ea);
         b = b - key&0xFF;
         b = b - 1;
         b = rotate_left(b, 6, 8, 0);
         b = b - 1;
         b = rotate_left(b, -2, 8, 0);
         b = -b;
         b = rotate_left(b, 3, 8, 0);
         b = b & 0xFF;
         a = key - b;
         key = (key&0xFFFFFF00) | ((a)&0xFF);
         ea = ea + 1;
         msg = form("%08X | %02X %02X       ebp-2; byte[memory[edi+%d]] -> word[ebp+0]\n", ea-2, oc, b, b);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 92 || oc == 110 || oc == 143 || oc == 147 || oc == 201 || oc == 205) {
         msg = form("%08X | %02X          word[ebp+0] + word[ebp+2] -(ebp-2)-> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 97 || oc == 152 || oc == 168 || oc == 250) {
         msg = form("%08X | %02X          fild    dword ptr [ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 98 || oc == 139 || oc == 181) {
         msg = form("%08X | %02X          ebp -(ebp-4)-> dword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 99 || oc == 124 || oc == 132 || oc == 170 || oc == 254) {
         msg = form("%08X | %02X          ~byte[ebp+0] AND ~byte[ebp+2] -(ebp-2)-> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 100 || oc == 119 || oc == 140 || oc == 178 || oc == 185 || oc == 200) {
         msg = form("%08X | %02X          ~word[ebp+0] AND word[ebp+4] -> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 104 || oc == 128 || oc == 214) {
         msg = form("%08X | %02X          byte[ebp+4] -> byte(ss:[[ebp+0]]); ebp+6\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 105 || oc == 141 || oc == 150 || oc == 225 || oc == 236) {
         msg = form("%08X | %02X          byte[ebp+0] + byte[ebp+2] -(ebp-2)-> byte[ebp+2]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 107 || oc == 117 || oc == 142 || oc == 206 || oc == 218 || oc == 239) {
         msg = form("%08X | %02X          word[ebp+0] SHR byte[ebp+2] -(ebp-2)-> word[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 108 || oc == 120 || oc == 126 || oc == 161 || oc == 192 || oc == 238 || oc == 247) {
         msg = form("%08X | %02X          dword(fs:[[ebp+0]]) -> dword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 137 || oc == 190 || oc == 203 || oc == 204 || oc == 207 || oc == 211) {
         b = Byte(ea);
         b = b + key&0xFF;
         b = rotate_left(b, 6, 8, 0);
         b = b ^ 0x64;
         b = -b;
         b = b ^ 0x30;
         b = b & 0xFF;
         a = key + b;
         key = (key&0xFFFFFF00) | ((a)&0xFF);
         ea = ea + 1;
         msg = form("%08X | %02X %02X       ebp-2; word[memory[edi+%d]] -> word[ebp+0]\n", ea-2, oc, b, b);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 144) {
         msg = form("%08X | %02X          dword[ebp+4] -> dword(fs:[[ebp+0]]); ebp+8\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 149 || oc == 180 || oc == 223) {
         msg = form("%08X | %02X          ebp-8; RDTSC -> dword64[ebp+0][ebp+4]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 154 || oc == 231) {
         msg = form("%08X | %02X          ~dword[ebp+0] AND ~dword[ebp+4] -> dword[ebp+4]; FLdword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else
      if(oc == 202 || oc == 209 || oc == 253) {
         msg = form("%08X | %02X          dword64[ebp+0][ebp+4] SHRD byte[ebp+8] -(ebp+2)-> dword[ebp+4]; FLdword -> dword[ebp+0]\n", ea-1, oc);
         Message("%s", msg);
         OutLog(flog, msg);
      } else {
         msg = form("%08X | opcode -> %02X; key -> %08X\n", ea, oc, key);
         Message("%s", msg);
         OutLog(flog, msg);
         break;
      }
   }
   CloseLog(flog);
   return;
}
